<template>
    <div>
        <div v-if="getPricePlan !== '' && getPricePlan !== undefined && getPricePlan !== null" class="checkout">
            <div class="checkout-banner hidden-md-and-up">
                <checkout-banner/>
            </div>
            <v-container id="checkout-container"
                         class="pt-0 pb-0 pt-md-12 pb-md-12"
                         fluid>
                <div>
                    <v-row v-if="getError.hasError">
                        <v-col cols="12">
                            <v-alert type="error"
                                     dark>
                                {{ getError.errorMessage }}
                            </v-alert>
                        </v-col>
                    </v-row>
                    <v-row
                        align-center
                        justify-center
                        class="checkout-form"
                        row
                        fill-height>
                        <v-col cols="12"
                               sm="12"
                               md="6"
                               class="px-0 px-md-4 py-0 py-md-4">
                            <checkout-form/>
                        </v-col>
                        <v-col cols="12"
                               sm="12"
                               md="6"
                               class="px-0 px-md-4 py-0 py-md-4">
                            <v-card class="checkout-pricing-card pb-10 my-xs-4"
                                    max-width="100%"
                                    height="550">
                                <v-card-title class="py-2 py-md-4 px-md-8 px-lg-8">
                                    Your growth plan
                                </v-card-title>
                                <component :is="component"
                                           :submit-btn="false"
                                           :class-name="'selected pt-10 pb-0 mt-6'"
                                           :list-benefit-class="'pb-0'"
                                           :height-plan="'400'"
                                           :description-plan="false"/>
                            </v-card>
                        </v-col>
                    </v-row>
                </div>
            </v-container>
        </div>
        <div v-else class="checkout-empty">
            <not-selected-pricing-plan/>
        </div>
    </div>
</template>

<script>/* eslint-disable */
import BronzePricingCard from '../pricing/cards/BronzePricingCard'
import CheckoutForm from '../checkout/components/CheckoutForm'
import { mapActions, mapGetters } from 'vuex'
import NotSelectedPricingPlan from './components/NotSelectedPricingPlan'
import SilverPricingCard from '../pricing/cards/SilverPricingCard'
import GoldPricingCard from '../pricing/cards/GoldPricingCard'
import FreeTrialCard from '../pricing/cards/FreeTrialCard'
import CheckoutBanner from './components/CheckoutBanner'

export default {
    name: 'Checkout',
    components: {
        'bronze-pricing-card': BronzePricingCard,
        'checkout-banner': CheckoutBanner,
        'checkout-form': CheckoutForm,
        'free-trial-card': FreeTrialCard,
        'gold-pricing-card': GoldPricingCard,
        'not-selected-pricing-plan': NotSelectedPricingPlan,
        'silver-pricing-card': SilverPricingCard
    },
    computed: {
        ...mapGetters(['getPricePlanSelected', 'getClientInfoError']),
        getPricePlan () {
            return this.getPricePlanSelected
        },
        getError () {
            return this.getClientInfoError
        },
        component () {
            let component = ''
            if (this.getPricePlanSelected === 'bronze') {
                component = 'bronze-pricing-card'
            } else if (this.getPricePlanSelected === 'silver') {
                component = 'silver-pricing-card'
            } else if (this.getPricePlanSelected === 'gold') {
                component = 'gold-pricing-card'
            } else {
                component = 'free-trial-card'
            }
            return component
        },
    },
    data: () => ({
        selectedPlan: true,
    }),

    created () {
        this.$store.dispatch('updatePricingPlan', sessionStorage.getItem('princingPlan'))
        this.resetState()
    },

    methods: {
        ...mapActions(['updatePricingPlan', 'resetState', 'sendClientInfo']),
    }
}
</script>

<style lang="scss" scoped>
    #checkout-container {
        &.container {
            max-width: 1470px!important;
        }
    }

    .checkout-banner {
        background-color: #833AB4;
    }
    .selected {
        margin: 0 auto;
        z-index: 1;
        box-shadow: none;
        border: 0;
    }

    .checkout {
        background-color: #f0f0f0;
        padding-bottom: 50px;
        @media(max-width: 960px) {
            background-color: #fff;
        }
        &-empty {
            padding: 0;
            background-color: #fff;
        }
        &-form {
            box-shadow: none;
            margin: 0 auto;
            border: 1px solid #f0f0f0;
            @media(max-width: 960px) {
                flex-direction: column-reverse;
                border: none;
            }
            .v-card__title {
                border-bottom: 1px solid #f0f0f0;
                @media(max-width: 960px) {
                    background-color: #f0f0f0;
                }
            }
        }
        &-pricing {
            &-card {
                border-bottom: 3px solid #0b9e9e;
                box-shadow: none;
                @media(max-width: 960px) {
                    border-top: 3px solid #f0f0f0;
                    border-right: 3px solid #f0f0f0;
                    border-left: 3px solid #f0f0f0;
                }
                &.my-xs-4 {
                    @media(max-width: 960px) {
                        margin-top: 16px!important;
                        margin-bottom: 16px!important;
                    }
                }
            }
        }
    }
</style>
